<template>
  <div class="sub-panel mb-5">
    <h2 class="mb-5">Inscription</h2>

    <b-form>
      <!-- <b-form @submit="onSubmit" @reset="onReset"> -->
      <b-container>
        <b-row align-h="around">
          <b-col md="6" lg="5">
            <h5 class="mb-4 mt-5">Données personnelles :</h5>
            <b-form-group label="Civilité*:">
              <b-form-radio-group id="radio-civilite" :options="civilite" name="civilite" v-model="info.civilite"></b-form-radio-group>
            </b-form-group>

            <b-form-group id="Nom" label="Nom*:" label-for="input-nom">
              <b-form-input id="input-nom" required placeholder="Votre Nom" v-model="info.name"></b-form-input>
            </b-form-group>

            <b-form-group id="Prenom" label="Prénom*:" label-for="input-Prenom">
              <b-form-input id="input-Prenom" required placeholder="Votre Prénom" v-model="info.firstName"></b-form-input>
            </b-form-group>

            <b-form-group id="anniversaire " label="Date d'anniversaire:" label-for="date-anniversaire">
              <b-form-input id="date-anniversaire" type="date" v-model="info.dateOfBirth"></b-form-input>
            </b-form-group>

            <b-form-group id="email" label="Email*:" label-for="input-email">
              <b-form-input id="input-email" type="email" required placeholder="Votre email" v-model="user.email"></b-form-input>
            </b-form-group>

            <b-form-group id="tel" label="Téléphone*:" label-for="input-tel">
              <b-form-input id="input-tel" type="tel" required placeholder="Votre numéro de téléphone" v-model="info.phoneNumber"></b-form-input>
            </b-form-group>

            <b-form-group id="passe" label="Mot de passe*:" label-for="input-passe">
              <b-form-input type="password" id="input-passe" required placeholder="Choisissez un mot de passe" v-model="user.password"></b-form-input>
            </b-form-group>
          </b-col>

          <b-col md="6" lg="5">
            <h5 class="mb-4 mt-5">Adresse de livraison :</h5>

            <b-form-group id="adreses-fact">
              <b-form-textarea id="textarea-adresse-fact" placeholder="Votre adresse de livraison" rows="3" max-rows="6" v-model="info.delivery[0].street"></b-form-textarea>
            </b-form-group>

            <b-form-group id="code-postal" label="Code Postal*:" label-for="input-code-postal">
              <b-form-input id="input-code-postal" required placeholder="Code Postal" v-model="info.delivery[0].postalCode"></b-form-input>
            </b-form-group>

            <b-form-group id="Ville" label="Ville*:" label-for="input-ville">
              <b-form-input id="input-ville" required placeholder="Ville" v-model="info.delivery[0].city"></b-form-input>
            </b-form-group>

            <b-form-group id="Pays" label="Pays*:" label-for="input-pays">
              <b-form-input id="input-pays" required placeholder="Pays" v-model="info.delivery[0].country"></b-form-input>
            </b-form-group>

            <b-button v-b-toggle.collapse-1 variant="primary" class="mt-5">Je suis un professionnel (facultatif) *</b-button>
            <b-collapse id="collapse-1" class="mt-2">
              <b-form-group id="societe" label="Société:" label-for="input-societe">
                <b-form-input id="input-societe" required placeholder="Raison sociale" v-model="info.companyNamePRO"></b-form-input>
              </b-form-group>

              <b-form-group id="siret" label="Siret n°:" label-for="input-siret">
                <b-form-input id="input-siret" required placeholder="Siret n°" v-model="info.siretPRO"></b-form-input>
              </b-form-group>

              <b-form-group id="NAF" label="Code NAF:" label-for="input-NAF">
                <b-form-input id="input-NAF" required placeholder="Code NAF" v-model="info.nafPRO"></b-form-input>
              </b-form-group>
            </b-collapse>
          </b-col>
        </b-row>

        <hr class="mt-5 mb-5" />

        <b-row align-h="around">
          <b-col md="6" lg="5">
            <b-form-group>
              <b-form-checkbox id="confidentialite" name="confidentialite" value="accepted" unchecked-value="not_accepted">
                En soumettant ce formulaire, j'accepte que les informations saisies soient exploitées dans le cadre de la relation commerciale qui peut en découler conformément à la <a href="#">politique de confidentialité</a>.
              </b-form-checkbox>
            </b-form-group>
            <p class="text-danger"><small>* champs obligatoires</small></p>
            <b-button type="submit" @click="validRegister($event)" variant="success" size="lg">Valider l'inscription</b-button>
          </b-col>
        </b-row>
      </b-container>
    </b-form>
  </div>
</template>
<script>
// test class
// import { Client } from "../../class/clientClass.js";
import { getHeader } from "@/config";
const MODULENAME = "clients1";
const URL_API = process.env.VUE_APP_URL_DISTANT_API;
const URL_CREATE_USER = URL_API + "api/users/create";
const URL_CREATE_CLIENT = URL_API + "api/clients/create";
const SITE_ALIAS = process.env.VUE_APP_SITE_ALIAS;

export default {
  mounted() {
    this.fillUser();
  },
  data() {
    return {
      info: {
        civilite: "",
        name: "",
        firstName: "",
        dateOfBirth: "",
        phoneNumber: "",
        delivery: [
          {
            street: "",
            postalCode: "",
            city: "",
            country: ""
          }
        ],
        companyNamePRO: "",
        siretPRO: "",
        nafPRO: ""
      },
      user: {
        email: "",
        password: "",
        sitealias: SITE_ALIAS,
        actif: true
      },
      adresse_fact: "",
      // Civilité
      selected: "Mme",
      civilite: [{ text: "Mme", value: "Mme" }, { text: "Mlle", value: "Mlle" }, { text: "Mr", value: "Mr" }, { text: "Mr et Mme", value: "Mr-Mme" }]
    };
  },
  methods: {
    fillUser() {
      // test - A enlever ensuite
      this.info = {
        civilite: "",
        name: "",
        firstName: "",
        dateOfBirth: "",
        phoneNumber: "",
        delivery: [
          {
            street: "",
            postalCode: "",
            city: "",
            country: ""
          }
        ],
        companyNamePRO: "",
        siretPRO: "",
        nafPRO: ""
      };

      this.user.email = "";
      this.user.password = "";
    },
    validRegister(evt) {
      evt.preventDefault();
      console.log("je validregister");
      // test class
      // let client = new Client(this.user);
      this.submitUser();
    },

    submitUser() {
      console.log("new user", this.user);
      // if (this.user.email !== "" && this.user.name !== "" && this.user.password !== "") {
      // EN COURS PAYLOAD
      // eventuellement faire requete pour connaitre indice numéro d'ordre
      // let dataClient = {
      //   name: MODULENAME,
      //   actif: true,
      //   ordre: 0,
      //   data: {
      //     titre1: this.info.civilite,
      //     titre2: this.info.name,
      //     titre3: this.info.firstName,
      //     titre4: this.info.dateOfBirth,
      //     titre5: this.info.email,
      //     titre6: this.info.phoneNumber,
      //     titre7: this.info.passWord,
      //     titre8: this.info.companyNamePRO,
      //     titre9: this.info.siretPRO,
      //     titre10: this.info.nafPRO
      //   },
      //   dataprix: {
      //     declinaisons: [
      //       {
      //         id: 1,
      //         reference: "Adresse 1",
      //         properties: [this.info.delivery[0].street, this.info.delivery[0].postalCode, this.info.delivery[0].city, this.info.delivery[0].country]
      //       }
      //     ]
      //   }
      // };

      // dataClient.sitealias = SITE_ALIAS;
      // dataClient.password_confirmation = this.user.passWord;

      // let dataClient = {};
      this.user.name = this.info.name;
      this.user.password_confirmation = this.user.password;

      // console.log("dataClient", dataClient);
      let payload = { user: this.user, info: this.info };

      this.$axios
        // .post(URL_CREATE_CLIENT, this.user, { headers: getHeader() })

        .post(URL_CREATE_CLIENT, payload)
        // .post(URL_CREATE_USER, tempoDataClient)
        .then(response => {
          console.log("user registered", response.data);
          // send mail création utilisateur ?
          // (this.$route.query.paheReturn)
          this.$router.push({ path: "compte-client", query: { action: "registered" } });
          console.log("redirection");
        })
        .catch(error => {
          console.log("error");
        });
      // } else {
      //   this.text = "Veuillez renseigner tous les champs correctement";
      //   this.snackbar = true;
      // }
    }
  }
};
</script>
